.TH cxcl 1 "December 2004" Unix Libraries

.SH NAME

cxcl - a Concatenative Language Interpreter Virtual-Machine based on the XCLE 
library parsing and execution capabilities.

.SH SYNOPSIS

.BI "cxcl -h | [-L] [-l module] | -H | -H " name " | [options] -f " file " | [options] " code-block ..."

.SH DESCRIPTION

The XCL compiler/interpreter is a generic command-line interface to the compiler
functionnalities of XCLE. It can parse and execute XCLE programs, respectively
from the command line, and with the 
.B -f
option, from files.


.SS Options:

.BR -h " | " --help "       :"
prints this help and returns 

.BR -v " | " --version "    :"
prints the version of this program 

.BR -L " | " --no-defload " :"
do not load default primitives modules 

.BR -l " | " --load "       :"
loads a binary primitives module 

.BR -H " | " --prim-list "  :"
prints the list of defined primitives in loaded modules 

.BR -H 
.IR <name> "         :"
prints information about the primitive 
.I <name>

.B --prim-info
.IR <name> ":"
prints information about the primitive 
.I <name>

.BR --prim-detail "     :"
prints information about all defined primitives 

.BR -f " | " --file "       :"
introduces a file name to be loaded 


.SS Verbosity options:

        A leading '-' followed by one or more characters among"

.B      c
.IR * "      : prints 'echo' comments in read file (started by ##)"

.B      C
.IR * "      : don't print 'echo' comments in read file"

.BR      r "        : prints error reports for each code-block"

.BR      R "        : don't print error reports"

.BR      s "        : prints all stack levels for each code-block"

.BR      S "        : prints all stack levels at the end of execution"

.BR      p "        : prints the first stack level for each code-block"

.BR      P "        : prints the first stack level at the end of execution"

.BR      0 "        : absolutely quiet execution - usefull for stack preload or verbosity reset"

       (
.I *
: only meaningfull when used with "-f file")


.SS Debugging options:
A leading '-u' string, enabeling the base debugging level, eventually followed by
characters in the range 1-9, A-Z specifying additional levels to turn on.

.SS Syntax:

Files must contain one code-block per line (use \\ before a \\n to wrap long lines).

Lines whose first character is # are comments, silently ignored, or echoed when the
TWO first characters are # and the -c flag is set.

A code-block is a space-separated list of
.TP
.B numbers   :
+3.141526e00  /  -12345 

.TP
.B strings   :
"hello world"

.TP
.B instructions  :
<HELP>  /  <*> 

.TP
.B barewords :
interpreted in order as numbers, then builtins, and strings if everything else failed

.TP
.B lists     :
[ foo bar 10 2 </> ] ( any of the above, separated by spaces and inside square brackets )


.SS Primitives:

To get the list of known primitives, type:

.B	"cxcl -H"

For specific help about some primitive, type:

.BI	"cxcl -H " <name>


.SH AUTHOR

.BI Author:   " Yann LANDRIN-SCHWEITZER"

.BI Contact:  " varkhan@varkhan.net"

.BI Homepage: " http://www.varkhan.net/"




.SH LICENSE

This library is free software;  you can redistribute it and/or modify it 
under  the terms of the  GNU Lesser General Public License  as published 
by the  Free Software Foundation;  either version 2.1 of the License, or 
(at your option) any later version.


This  library  is  distributed  in  the hope that it will be useful, but 
WITHOUT   ANY   WARRANTY;   without   even   the   implied  warranty  of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser 
General Public License for more details.


You should have received a copy of the GNU Lesser General Public License 
along with this library;  if not, write to the Free Software Foundation, 
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

